;-------------------------------------------------
;	PB-1000/C 128KB RAM check program
;-------------------------------------------------

PB1000:	EQU	1
PB1000C:EQU	2

;-------------------------------------------------
MODEL:	EQU	PB1000
;-------------------------------------------------

CGRAM:	EQU	&H6B4A
#if MODEL=PB1000
RWERR:	EQU	&HABD4		;RW error
#else
RWERR:	EQU	&HAD23		;RW error
#endif

	ORG	CGRAM
	START	START
;
;	00C10-05FFFh (bank0)
;
START:	LDW	$0,&H6000	;end address + 1 = &H6000
	LDW	$2,&H0C10	;start address   = &H0C10
	CAL	VERIFY
;
;	28000-2FFFFh (bank2)
;
	PST	UA,&H20		;ix = bank 2
	LD	$1,$31		;end address + 1 = &H0000
	LDW	$2,&H8000	;start address   = &H8000
	CAL	VERIFY
;
;	38000-3FFFFh (bank3)
;
	PST	UA,&H30		;ix = bank 3
	CAL	VERIFY

	PST	UA,&H50		;reset ua resitor
	RTN
;
;	verify routine
;
VERIFY:	LD	$4,$31		;initialize test data
	PRE	IX,$2		;set start address
WRITE:	STI	$4,(IX+$31)	;write test data
	AD	$4,$30		;increment test data
	GRE	IX,$5		;
	SBCW	$5,$0		;end check
	JR	NZ,WRITE	;

	LD	$4,$31		;initialize test data
	PRE	IX,$2		;set start address
READ:	SBC	(IX+$31),$4	;compare data
	JR	NZ,ERROR	;
	STI	$31,(IX+$31)	;write 00h
	AD	$4,$30		;increment test data
	GRE	IX,$5		;
	SBCW	$5,$0		;end check
	JR	NZ,READ		;

	RTN
;
;	RW error
;
ERROR:	PST	UA,&H50		;reset ua resitor
	JP	RWERR
